;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname battleship-fire) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #t #t none #f ())))
(require "battleship-data.rkt")
(require "provide.rkt")
(provide opponent-hits
         opponent-update)
         
;; combine-resp : response resposne -> response
(define (combine-resp a b)
  (cond
    [(eq? a 'miss) b]    
    [(eq? a 'hit) 'hit]
    [(number? a) a]))

;; opponent-hits-boat : posn list-of-hpeg -> response
(define (opponent-hits-boat p b)
  (cond
    [(empty? b) 'miss]
    [(cons? b) (local ([define a-hit? (equal? p (hpeg-loc (first b)))]
                       [define b-resp (opponent-hits-boat p (rest b))])
                 (cond
                   [(not a-hit?) (if (number? b-resp)
                                     (if (hpeg-hit? (first b))
                                         (add1 b-resp)
                                         'hit)
                                     b-resp)]
                   [a-hit? (if (andmap hpeg-hit? (rest b))
                               (length b)
                               'hit)]))]))

(check-expect (opponent-hits-boat (make-posn 0 0) empty)
              'miss)
(check-expect (opponent-hits-boat (make-posn 0 0) boat-2)
              'miss)
(check-expect (opponent-hits-boat (make-posn 0 0) boat-3)
              'hit)
(check-expect (opponent-hits-boat (make-posn 5 7) boat-2)
              2)

;; opponent-hits-any-boat : posn list-of-boat -> response
(define (opponent-hits-any-boat p h)
  (cond
    [(empty? h) 'miss]
    [(cons? h) (combine-resp
                (opponent-hits-boat p (first h))
                (opponent-hits-any-boat p (rest h)))]))


(check-expect (opponent-hits-any-boat (make-posn 0 0) (list boat-2))
              'miss)
(check-expect (opponent-hits-any-boat (make-posn 0 0) (list boat-2 boat-3))
              'hit)
(check-expect (opponent-hits-any-boat (make-posn 5 7) (list boat-2))
              2)
(check-expect (opponent-hits-any-boat (make-posn 5 7) (list boat-2 boat-3))
              2)

;; opponent-hits : posn board -> response
(define (opponent-hits p b)
  (opponent-hits-any-boat p (board-home b)))

(check-expect (opponent-hits (make-posn 4 0)
                              board-1)
              'miss)
(check-expect (opponent-hits (make-posn 2 0)
                              board-1)
              'hit)
(check-expect (opponent-hits (make-posn 5 7)
                              board-1)
              2)

;; opponent-update-hpeg : posn hpeg -> hpeg
(define (opponent-update-hpeg p hp)
  (make-hpeg (hpeg-loc hp)
             (or (equal? p (hpeg-loc hp)) 
                 (hpeg-hit? hp))))

(check-expect (opponent-update-hpeg (make-posn 1 2)
                                    (make-hpeg (make-posn 1 2) #f))
              (make-hpeg (make-posn 1 2) #t))
(check-expect (opponent-update-hpeg (make-posn 1 2)
                                    (make-hpeg (make-posn 2 1) #f))
              (make-hpeg (make-posn 2 1) #f))
(check-expect (opponent-update-hpeg (make-posn 1 2)
                                    (make-hpeg (make-posn 2 1) #t))
              (make-hpeg (make-posn 2 1) #t))

;; opponent-update-boat : posn list-of-hpeg -> list-of-hpeg
(define (opponent-update-boat p lohp)
  (map (lambda (hp) (opponent-update-hpeg p hp))
       lohp))

;; opponent-update-all-boats : posn list-of-boat -> list-of-boat
(define (opponent-update-all-boats p lob)
  (map (lambda (b) (opponent-update-boat p b))
       lob))

;; opponent-update : posn board -> board
(define (opponent-update p b)
  (make-board
   (board-away b)
   (opponent-update-all-boats p (board-home b))))
   
(check-expect (opponent-update (make-posn 4 0) board-1)
              board-1)
(check-expect (opponent-update (make-posn 2 0) board-1)
              (make-board away-view-1
                          (list boat-2
                                boat-3-after-hit)))
